
"use strict";

var path = require( 'path' ),
    cube = require( 'node-cube' );

function MiddlewareCube( options ) {
  var middleware = true,
      dir, assetsDir, cached, maxAge, processors;
  dir    = options.dir;
  cached = options.cached || false;
  maxAge = options.maxAge || 0;
  processors = options.processors || [];
  for( var i = 0; i < processors.length; i ++ ) {
    var psPath = processors[ i ];
    processors[ i ] = path.join( __dirname, './node_modules', psPath );
  }
  if( options.middleware ) {
    middleware = options.middleware;
  }
  assetsDir = path.join( __dirname, '../../', dir );
  this.scriptProcessor = cube.init( {
    middleware : middleware,
    root       : assetsDir,
    cached     : cached,
    maxAge     : maxAge,
    processors : [ 'cube-ejs', 'cube-jade', 'cube-less', 'cube-stylus' ].concat( processors )
  } );
}

MiddlewareCube.prototype.middleware = function() {
  return this.scriptProcessor;
};

module.exports = function( options ) {
  return new MiddlewareCube( options );
};
